Page MenuHomeFreeBSD

Enable high-speed on the card before increasing frequency on the controller
ClosedPublic

Authored by kibab on May 25 2018, 9:46 AM.

Details

Summary

Increasing operating frequency without telling card to switch to high-speed mode first upsets some cards and generates CRC errors.
While here, deselect / reselect cards after CMD6 and SCR fetch, as in original code.

Test Plan

This diff enables normal operation for the following card: <SDHC SL16G 8.0 SN 19853490 MFG 01/2017> with Raspberry Pi 3 host.

Diff Detail

Repository
rS FreeBSD src repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

kibab created this revision.May 25 2018, 9:46 AM
imp accepted this revision.Jun 4 2018, 8:27 PM

other than the minor style nits, this looks good.

sys/cam/mmc/mmc_da.c
904 ↗(On Diff #42975)

style says this { is alone on the next line.

905 ↗(On Diff #42975)

and no blank line here.

This revision is now accepted and ready to land.Jun 4 2018, 8:27 PM
kibab marked 2 inline comments as done.Jun 5 2018, 11:03 AM
This revision was automatically updated to reflect the committed changes.